# -*- coding: ISO-8859-1 -*-
# Copyright (C) 2005 Christian Mauduit <ufoot@ufoot.org>

from mod_python import apache
#from itools.web import mod_python_app

def handler(req):
    """This is a test handler, to check wether mod_python works or not."""
    req.content_type = "text/plain"
    req.write("Hello World!")
    return apache.OK

## # This could be an itools.web based handler
## def handler(req):
##     """This is a test handler, to check wether mod_python works or not."""
##     app=mod_python_app.Application("/",req)
##     app.run()
##     return apache.OK

## # Corresponding code to be put in itools/web/mod_python_app

## # Import from mod_python
## from mod_python import apache
## from mod_python.util import FieldStorage

## # Import from itools
## from itools import uri
## from itools.web.context import Context, get_context, set_context
## from itools.web.request import Request
## from itools.web import application


## class Application(application.Application):
##     def __init__(self, root_reference, mod_python_req):
##         """Initialize appplication object with the mod_python
##         request object, which stores pretty much everything
##         necessary to handle both request and response aspects."""
##         application.Application.__init__(self,root_reference)
##         self.mod_python_req = mod_python_req

##     def init_context(self):
##         # Build the request
##         request = Request()

##         # environ
##         environ=self.mod_python_req.subprocess_env

##         # The request method
##         request_method = self.mod_python_req.method
##         request.set_method(request_method)

##         # The path
##         path = self.mod_python_req.path_info # need to handle None?
##         request.set_path(path)

##         # The referrer
##         if 'HTTP_REFERER' in environ:
##             request.set_header('Referer', environ['HTTP_REFERER'])

##         # The form
##         if request_method == 'GET':
##             data = environ['QUERY_STRING']
##         elif request_method == 'POST':
##             content_length = environ['CONTENT_LENGTH']
##             data = stdin.read(content_length)
##         else:
##             raise ValueError, 'method "%s" not yet supported' % request_method

##         # Parse the form data
##         for parameter in data.split('&'):
##             if parameter:
##                 key, value = parameter.split('=', 1)
##                 request.state.form[key] = value

##         field_storage=FieldStorage(self.mod_python_req)
##         for key in field_storage.list:
##             request.state.form[key] = field_storage.getvalue(key,"")

##         # Cookies: Todo...

##         # Build the context
##         context = Context(request)
##         set_context(context)


## ##        # The request URI
## ##        request_uri = self.mod_python_req.unparsed_uri.split(".")[0]
## ##        request.set_uri(request_uri)



##     def send_response(self):
##         response = get_context().response.to_str()
##         # Remove status line
##         self.mod_python_req.write('\n'.join(response.splitlines()[1:]))



