// Code concerning the browser / treeview

var pgw_selected_user_id=0;
var pgw_selected_file_id=0;
var pgw_selected_waypoint_id=0;
var pgw_selected_route_id=0;
var pgw_selected_track_id=0;

function pgwBrowserOnSelect() {
  browser=document.getElementById("browser");
  index=browser.view.selection.currentIndex;
  if (index>=0) {
    item=browser.view.getItemAtIndex(index);
    user_re=/browser\/\d+$/;
    if (item.id.search(user_re)!=-1) {
      pgwEnterEditUser(item.id);
    }
    file_re=/browser\/\d+\/\d+$/;
    if (item.id.search(file_re)!=-1) {
      pgwEnterEditFile(item.id);
    }
    waypoints_re=/waypoints$/;
    if (item.id.search(waypoints_re)!=-1) {
      pgwEnterEditWaypoints(item.id);
    }
    routes_re=/routes$/;
    if (item.id.search(routes_re)!=-1) {
      pgwEnterEditRoutes(item.id);
    }
    tracks_re=/tracks$/;
    if (item.id.search(tracks_re)!=-1) {
      pgwEnterEditTracks(item.id);
    }
    waypoint_re=/waypoints\/\d+$/;
    if (item.id.search(waypoint_re)!=-1) {
      pgwEnterEditWaypoint(item.id);
    }
    route_re=/routes\/\d+$/;
    if (item.id.search(route_re)!=-1) {
      pgwEnterEditRoute(item.id);
    }
    track_re=/tracks\/\d+$/;
    if (item.id.search(track_re)!=-1) {
      pgwEnterEditTrack(item.id);
    }
    pgwRefreshData();
    pgwUpdateMenu();
  } else {
    // nothing selected, disable everything
    pgwClearSelected();
  }
}

function pgwClearSelected() {
  pgw_selected_user_id=0;
  pgw_selected_file_id=0;
  pgw_selected_waypoint_id=0;
  pgw_selected_route_id=0;
  pgw_selected_track_id=0;
}

function pgwUpdateBrowser() {
  browser=document.getElementById("browser");
  browser.setAttribute("ref","http://www.ufoot.org/pygpsweb/browser");
  browser.setAttribute("datasources","browser.rdf?&timestamp="+pgwTimestamp());
  browser.builder.refresh();  	
}



