// Code which calls the server to modify data.

function pgwSoapCall(method, params, callback) {
  var h = new Array();
  var p = new Array();
  var param;

  var i=0;
  p[i++] = new SOAPParameter(pgwGetUserId(), "user_id");
  p[i++] = new SOAPParameter(pgwGetUserPasswd(), "user_passwd");
  for (par in params) {
    p[i++] = new SOAPParameter(params[par], par);
  }

  var call = new SOAPCall( );

  call.transportURI = pgw_soap_service; // http://.../service.soap

  call.encode(0, method, pgw_soap_service, 0, null, p.length, p);

  call.asyncInvoke(function (response, soapcall, error) {
    /*
     * See http://books.mozdev.org/html/mozilla-chp-12-sect-9.html
     * for now we don't get SOAP return values. Might be linked
     * to the fact it doesn't really work from XUL??? Mmm, who knows...
     */
    //alert(response.getParameters(false,{}));
    callback();
  }
		   );
}

function pgwAddRoutePoint(name,x,y,z) {
  pgwSoapCall("AddRoutePoint",{"Name":name,
				 "X":x,
				 "Y":y,
				 "Z":z,
				 "RouteId":pgw_selected_route_id},
	      pgwRefreshData);
}

function pgwDeleteLastWaypoint() {
  pgwSoapCall("DeleteLastWaypoint",{},
	      pgwRefreshData);
}

function pgwNewFile() {
  pgwSoapCall("NewFile",{},
	      pgwRefreshData);
}
